//+------------------------------------------------------------------+
//|                                                     SCR_Fibo.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                              http://www.mql4.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.mql4.ru/"
#property show_inputs
#include <stdlib.mqh>

extern double Base_Lot       = 0.1;   //  
extern double Lot_0.23       = 0.01;  //    0,23 
extern double Lot_0.38       = 0.01;  //    0,38 
extern double Lot_0.5        = 0.02;  //    0,5 
extern int    MagicNumber    = 23032012;   //23.03.2012

//  
int           CountLevels;
double        OpenPrice[10];
double        Price;
bool          rez;
int           Type;
double        StopLoss;
double        TakeProfit;

double        Lot_0.61;
double        SL_0.61;
double        SL_0.5;
double        SL_0.38;
double        SL_0.23;

bool          MarketEx      = True;                //  
bool          gbDisabled    = False;               // 
bool          UseSound      = TRUE;
string        NameFileSound = "expert.wav";
color         clOpenBuy     = Blue;
color         clOpenSell    = Red;
color         clModifyBuy   = Aqua;
color         clModifySell  = Tomato;
color         clCloseBuy    = Yellow;
color         clCloseSell   = Green;
color         clDelete      = Yellow; //    
int           NumberOfTry   = 15;
int           Slippage      = 3;               //  
string        SoundSuccess  = "ok.wav";        //  
string        SoundError    = "timeout.wav";   //  
string        lotsinfo; 
int           modeSetOrders = 1;      //   :
                                      //  0 -   
                                      //  1 -  
                                      //  2 -    
                                       

//+----------------------------------------------------------------------------+
//|  script program start function                                             |
//+----------------------------------------------------------------------------+
int start()
{
//----
  FindFibo();
  
  if(rez==true)
  {
    //for(int i = 0; i < CountLevels; i++)
    for(int i = 1; i < 5; i++) //  ,       
    {
      Type = -1; //     
      //=====================   SELL- ================================
      RefreshRates();
      if(OpenPrice[i] > Bid) //    Bid,   SellLimit
      {
        Type = OP_SELLLIMIT;
        Price = OpenPrice[i];
      }
      //=====================    ================================
      if(Type != -1) //   ,  
      {        
        if(NumberOfOrders(NULL, -1, MagicNumber) <=3 )
        {
          if(Price==OpenPrice[1])
          {
            SetOrder(NULL, Type, Lot_0.23, Price, StopLoss, TakeProfit, MagicNumber, "", 0);
          } 
          if(Price==OpenPrice[2])
          {
            SetOrder(NULL, Type, Lot_0.38, Price, StopLoss, TakeProfit, MagicNumber, "", 0);
          } 
          if(Price==OpenPrice[3])
          {
            SetOrder(NULL, Type, Lot_0.5, Price, StopLoss, TakeProfit, MagicNumber, "", 0);
          } 
          if(Price==OpenPrice[4])
          {
            //    ,         , 
            //         0,61 
            Lot_0.61=NormalizeDouble( (Base_Lot*SL_0.61-Lot_0.23*SL_0.23-Lot_0.38*SL_0.38-Lot_0.5*SL_0.5)/SL_0.61, 2);
            SetOrder(NULL, Type, Lot_0.61, Price, StopLoss, TakeProfit, MagicNumber, "", 0);
          } 
        }  
      }  
    }
  }   
//----
  return(0);
}
//+------------------------------------------------------------------+
//      :
void FindFibo()
{
  if (ObjectsTotal(OBJ_FIBO) > 0)
  {
    //===============       ==============
    for(int i = ObjectsTotal()-1; i >= 0; i--)
    {
      if(ObjectType(ObjectName(i)) == OBJ_FIBO)
      {
        break;
      }
    }    
    //=================      ===============
    string Name      = ObjectName(i);
    double ZeroLevel = ObjectGet(Name, OBJPROP_PRICE2);
    double Level100  = ObjectGet(Name, OBJPROP_PRICE1);
    CountLevels      = ObjectGet(Name, OBJPROP_FIBOLEVELS);
    
    for(i=0; i<CountLevels; i++)//       
    {
      double Level = ObjectGet(Name, OBJPROP_FIRSTLEVEL+i);
      if(Level==1)
      {
        StopLoss = ND(ZeroLevel - (ZeroLevel - Level100)*Level); // StopLose =  100%
      }
      if(Level==0)
      {
        TakeProfit = ND(ZeroLevel - (ZeroLevel - Level100)*Level);// TakeProfit =  0%
      }
    }
    
    for (i=0; i<CountLevels; i++)//   0,23; 0,38; 0.5; 0.61
    {
      Level = ObjectGet(Name, OBJPROP_FIRSTLEVEL+i);
      if(Level!=0 && Level!=1 && Level!=1.618 && Level!=2.618 && Level!=4.236)
      {
        OpenPrice[i] = ND(ZeroLevel - (ZeroLevel - Level100)*Level);
        if(Level==0.236)
        {
          SL_0.23=MathAbs( (StopLoss-OpenPrice[i])*Point );
        }
        if(Level==0.382)
        {
          SL_0.38=MathAbs( (StopLoss-OpenPrice[i])*Point );
        }
        if(Level==0.5)
        {
          SL_0.5=MathAbs( (StopLoss-OpenPrice[i])*Point );
        }
        if(Level==0.618)
        {
          SL_0.61=MathAbs( (StopLoss-OpenPrice[i])*Point );
        }
      }  
    }
    rez = true;
  }
  else
  {
    if(ExistOrders(NULL, OP_SELLLIMIT, MagicNumber, 0) == true)//   SellLimit, 
    {
      DeleteOrders(NULL, OP_SELLLIMIT, MagicNumber);
    }       
    Alert("     !");
    rez = false;
  }
}


//----------------------------------------------------------------------------------------------- 
double ND(double v){return(NormalizeDouble(v,Digits));}
//-----------------------------------------------------------------------------------------------

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 02.08.2008                                                     |
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    co -                                                         |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double ll, double pp, double sl=0, double tp=0, int mn=0, string co="", datetime ex=0) 
{
  color    cl=CLR_NONE;//IIFc(op==OP_BUYLIMIT || op==OP_BUYSTOP, clOpenBuy, clOpenSell);
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, ex, cl);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        continue;
      }
      if (UseSound) PlaySound(SoundError);
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Message("SetOrder():       "+sy);
      Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      //  
      if (err==130) {
        //   
        if (modeSetOrders==1) {
          Sleep(1000*5.3);
          switch (op) {
            case OP_BUYLIMIT:
              if (pp>pa-msl*mp) pp=pa-msl*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_BUYSTOP:
              if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_SELLLIMIT:
              if (pp<pb+msl*mp) pp=pb+msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
            case OP_SELLSTOP:
              if (pp>pb-msl*mp) pp=pb-msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
          }
          Print("SetOrder():   ");
          continue;
        }
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:		   return("UnknownPeriod");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :   .                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int NumberOfOrders(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), ko=0, ot;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) ko++;
        }
      }
    }
  }
  return(ko);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :                                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int  err, i, it, k=OrdersTotal(), ot;

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            for (it=1; it<=NumberOfTry; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), clDelete);
              if (fd) {
                if (UseSound) PlaySound(SoundSuccess); break;
              } else {
                err=GetLastError();
                if (UseSound) PlaySound(SoundError);
                Print("Error(",err,") delete order ",GetNameOP(ot),": ",ErrorDescription(err),", try ",it);
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}

